/********************************************************/
/* CMPSCI 603 - example                                 */
/********************************************************/
#include <stdlib.h>
#include <stdio.h>

#include "pgm_interface.h"

void main (argc, argv)
int argc;
char *argv[];
{
  IMAGE *g, *read_image();
  static char g_filename[32] = "images/test_image.pgm";
  static char h_filename[32] = "out_image.pgm";
  FILE *fp, *fopen();
  int x, y, address, min, max;

  /* read input image */
  g = read_image(g_filename);
  printf ("Image %s: width %d, height %d, maxval %d\n",
	    g_filename, g->width, g->height, g->maxval);

  min = 256; max = -1;
  for (x=0; x<(g->width); ++x) {
    for (y=0; y<(g->height); ++y) {
      address = y*(g->width)+x;
      g->image[address] = 255 - g->image[address]; /* invert the image */
      if (g->image[address] > max) max = g->image[address];
      if (g->image[address] < min) min = g->image[address];
    }
  }
  re_map(g, min, max);

  write_image(g, h_filename);

  free_image(g);
  exit(0);
}

cross_correlation(f,alpha,beta,g,h,hmin,hmax) 
IMAGE *f, *g, *h;
int alpha, beta, *hmin, *hmax;
{
  int i,j,x,y,sum;

  *hmax = 0; *hmin = BIGNUM;
  for (x=alpha;x<(g->width - alpha); ++x) {
    printf("%d\n", x);
    for (y=beta; y<(g->height - beta); ++y) {
      sum = 0;
      for (i= -(alpha); i<=alpha; ++i) {
	for (j= -(beta); j<=beta; ++j) {
	  sum += g->image[(y+j)*(g->width) + (x+i)] * 
	    f->image[(j+beta)*(f->width) + (i+alpha)];
	}
      }
      h->image[(y-beta)*(h->width) + (x-alpha)] = sum;
      if (sum > *hmax) *hmax = sum;
      if (sum < *hmin) *hmin = sum;
    }
  }
}


